
# First example of exceptions
def f(x,y):
   result=x/y
   print(result)
   return result

def g(x,y):
   return f(x,y)

def h(x,y):
    return g(x,y)

h(1.0,0.0)


# Exception handling and functions (Example)
def f(x, y):
    try:
        return g(x, x+y)
    except ZeroDivisionError:
        return 0
    except TypeError:
        return 1
    
def g(x, y):
    try:
        return x / y
    except TypeError:
        return None

f(2, -2)
f("ab", "cd")
f("ab", 2)

# Bad practice example (delayed error)
def average(seq):
    try:
        return sum(seq) / len(seq)
    except ZeroDivisionError:
        print("empty sequence!")

a_seq=[]
b_seq=[1,2,3]
avg1=average(a_seq)
avg2=average(b_seq)
if avg1 < avg2:
    print("average of a_seq is smaller than that of b_seq")


# Good practice example 
def input_number():
    """Input a number from keyboard with error checking"""
    number = None
    while number is None:
        try:
            ans = input("Enter PIN:")
            number = int(ans)
        except ValueError:
            print("That's not a number!")
            number = None
    return number

num=input_number()
print("You entered: ", num)